/*
    CFS0.11 filesystem implementation for FUSE
    Copyright (C) 2005-2020 Kajtar Zsolt (Soci/Singular) <soci@c64.rulez.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/
#ifndef BUFFER_H
#define BUFFER_H
#include "block.h"

typedef struct Buffer {
    Offset offset;
    int dirty;
    int next;
    int fault;
    Block block;
} Buffer;

extern void buffers_init(void);
extern int buffer_flush(Buffer *buffer);
extern Buffer *buffer_write(Offset ide);
extern Buffer *buffer_write_once(Offset ide);
extern Buffer *buffer_read(Offset ide);
extern Buffer *buffer_read_once(Offset ide);
extern void buffer_done(Buffer *buffer);
extern int buffers_sync(int ret);
#endif
